#!/bin/bash
echo '--- CREATING SWAP FILE ---'
sudo bash set_Env.sh

echo '--- UPDATING SYSTEM ---'
sudo apt-get update

echo '--- INSTALLING REQUIRED LIBS FOR OPENCV, PYTHON 3.5 E TENSORFLOW---'
sudo apt install -y protobuf-compiler gcc-aarch64-linux-gnu g++-aarch64-linux-gnu debootstrap schroot git curl pkg-config zip unzip python python-pip g++ zlib1g-dev openjdk-8-jdk libhdf5-dev libatlas-base-dev gfortran v4l-utils hdf5* libhdf5* libpng-dev build-essential cmake libreadline-gplv2-dev libncursesw5-dev libssl-dev libsqlite3-dev tk-dev libgdbm-dev libc6-dev libbz2-dev libjpeg-dev libtiff5-dev libpng-dev libavcodec-dev libavformat-dev libswscale-dev libv4l-dev libxvidcore-dev libx264-dev libgtk2.0-dev libgtk-3-dev ffmpeg python-opengl                     

echo '--- INSTALLING PYTHON3.5 ---'
cd /usr/src
sudo wget https://www.python.org/ftp/python/3.5.6/Python-3.5.6.tgz
sudo tar xzf Python-3.5.6.tgz
sudo rm Python-3.5.6.tgz
cd Python-3.5.6
sudo ./configure --enable-optimizations
sudo make altinstall
sudo python3.5 -m pip install --upgrade pip
sudo python3.5 -m pip install --upgrade setuptools

echo '--- INSTALLING NUMPY FOR PYTHON3.5 ---'
sudo python3.5 -m pip install numpy

echo '--- INSTALLING TENSORFLOW 1.12---'
cd ~
wget https://github.com/lhelontra/tensorflow-on-arm/releases/download/v1.12.0/tensorflow-1.12.0-cp35-none-linux_aarch64.whl
sudo python3.5 -m pip install tensorflow-1.12.0-cp35-none-linux_aarch64.whl

echo '--- CLONING OPENCV 3.4 ---'
cd /
cd /media/sdcard
sudo git clone -b 3.4 https://github.com/opencv/opencv.git
sudo git clone -b 3.4 https://github.com/opencv/opencv_contrib.git

echo '--- COMPILING OPENCV 3.4 ---'
cd opencv
sudo mkdir build
cd build
sudo cmake -D CMAKE_BUILD_TYPE=RELEASE -D CMAKE_INSTALL_PREFIX=/usr/local -D BUILD_opencv_java=OFF -D BUILD_opencv_python=OFF -D BUILD_opencv_python3=ON -D PYTHON3_DEFAULT_EXECUTABLE=$(which python3.5) -D PYTHON3_EXECUTABLE:FILEPATH=$(which python3.5) -D PYTHON_INCLUDE_DIR=/usr/local/include/python3.5m/ -D INSTALL_C_EXAMPLES=OFF -D INSTALL_PYTHON3_EXAMPLES=OFF -D BUILD_EXAMPLES=OFF -D WITH_CUDA=OFF -D BUILD_TESTS=OFF -D WITH_TBB=ON -DBUILD_TBB=ON -D OPENCV_ENABLE_NONFREE=ON -DBUILD_opencv_xfeatures2d=OFF -D OPENGL=ON -D OPENMP=ON -D ENABLE_NEON=ON -D BUILD_PERF_TESTS= OFF -D BUILD_OPENCV_DNN=ON -D OPENCV_EXTRA_MODULES_PATH=../../opencv_contrib/modules ..
sudo make -j 2

echo '--- INSTALLING OPENCV 3.4 ---'
sudo make install

echo '--- PACKAGES INSTALLED ---'
echo '--- [INFO] Install python requirements with: "sudo python3.5 -m pip install -r requirements.txt" ---'
